GNU bug report logs - #8635
Some Fortran files don't have the extensions automake wants

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: automake; Severity: wishlist; Reported by: Peter Williams <pwilliams@HIDDEN>; dated Sat, 7 May 2011 17:14:02 UTC; Maintainer for automake is bug-automake@HIDDEN.

Message received at 8635 <at> debbugs.gnu.org:


Received: (at 8635) by debbugs.gnu.org; 10 May 2011 18:11:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue May 10 14:11:27 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1QJrP4-0006IV-Ms
	for submit <at> debbugs.gnu.org; Tue, 10 May 2011 14:11:27 -0400
Received: from chandra.berkeley.edu ([128.32.92.22])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <pwilliams@HIDDEN>) id 1QJrP2-0006II-5D
	for 8635 <at> debbugs.gnu.org; Tue, 10 May 2011 14:11:25 -0400
Received: from [128.32.92.174] (cosmic [128.32.92.174])
	by chandra.berkeley.edu (Postfix) with ESMTP id 4732688994;
	Tue, 10 May 2011 11:11:18 -0700 (PDT)
Subject: Re: bug#8635: Some Fortran files don't have the extensions
	automake wants
From: Peter Williams <pwilliams@HIDDEN>
To: Stefano Lattarini <stefano.lattarini@HIDDEN>,
	Ralf Wildenhues <Ralf.Wildenhues@HIDDEN>
In-Reply-To: <201105092140.09908.stefano.lattarini@HIDDEN>
References: <1304735907.4245.218.camel@HIDDEN>
	<201105091411.53899.stefano.lattarini@HIDDEN>
	<1304966145.4245.229.camel@HIDDEN>
	<201105092140.09908.stefano.lattarini@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Organization: Astronomy Department, UC Berkeley
Date: Tue, 10 May 2011 11:11:17 -0700
Message-ID: <1305051078.4245.262.camel@HIDDEN>
Mime-Version: 1.0
X-Mailer: Evolution 2.28.2 
Content-Transfer-Encoding: 7bit
X-Spam-Score: -6.6 (------)
X-Debbugs-Envelope-To: 8635
Cc: 8635 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.6 (------)

On Mon, 2011-05-09 at 21:40 +0200, Stefano Lattarini wrote:
> Hmm... I don't like this solution either; it still sounds a little too
> hackish, and to me it seems wrong to have to declare project policy
> decisions that are system-independent and relevant only for automake
> (in this case, the policy decision being "use the `*.for' extension
> for Fortran 90 sources") in the configure.ac file.
> OTOH, some times ago a patch has been proposed which would allow user
> extensions to the languages handled/understood by Automake:
> <http://lists.gnu.org/archive/html/automake/2010-09/msg00003.html>
> IMHO, resurrecting it (and possibly improving it to naturally serve
> your user case) would be the best way to fix your problem (and similar
> ones) in the long run.

Thanks for your thoughts. I'm willing to do a little bit of work to get
this bug fixed, but I don't have the time to make a major revision to
automake's internals, which it sounds this patch would entail. (Though
as a longtime automake user I definitely agree that more extensibility
would be awesome.)

Ralf, I think I understand what you mentioned about AC_FC_SRCEXT, and
that sounds like a nice approach. Is work actively being done on hooking
up those macros to Automake's language-choosing apparatus? If I wanted
that to happen, would I realistically have to do it myself?

Thanks,

Peter

> 
> Regards,
> 
> Stefano


-- 
Peter Williams / pwilliams@HIDDEN
Department of Astronomy, UC Berkeley





Information forwarded to owner <at> debbugs.gnu.org, bug-automake@HIDDEN:
bug#8635; Package automake. Full text available.

Message received at 8635 <at> debbugs.gnu.org:


Received: (at 8635) by debbugs.gnu.org; 9 May 2011 19:43:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 09 15:43:24 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1QJWMW-00087A-3j
	for submit <at> debbugs.gnu.org; Mon, 09 May 2011 15:43:24 -0400
Received: from mail-ww0-f46.google.com ([74.125.82.46])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1QJWMT-00086x-5v
	for 8635 <at> debbugs.gnu.org; Mon, 09 May 2011 15:43:22 -0400
Received: by wwb28 with SMTP id 28so5981114wwb.15
	for <8635 <at> debbugs.gnu.org>; Mon, 09 May 2011 12:43:15 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=domainkey-signature:from:to:subject:date:user-agent:cc:references
	:in-reply-to:x-kmail-markup:mime-version:content-type
	:content-transfer-encoding:message-id;
	bh=WDTCod1gbkfULb01WZ9GR66CR2XNA3xxyChJnFcMskA=;
	b=YKedgiLfBjt6WFYdDpVXdBeAliuHaZ+ri6V1pLswu2tSGNDy54ORoUaGnYf8d5Kfv7
	QYrT6WWfJL6tm/MxL0d5uwM0qqMugk+Dpfra8qi6Yjs4QAEId3HFIPx5eBzgoGqQnTVN
	p6h/jpGOW9tb300ipxZXSDYbrTInzoGcw7AmE=
DomainKey-Signature: a=rsa-sha1; c=nofws; d=gmail.com; s=gamma;
	h=from:to:subject:date:user-agent:cc:references:in-reply-to
	:x-kmail-markup:mime-version:content-type:content-transfer-encoding
	:message-id;
	b=FXCglldJGzSkY6ulu+6DnQVrP8Urh/70ZAyaUZEHfk8lixxRTdqb4pHGzupp0Kjb7w
	8v8ur11q4krve1RWhcMxAWVto1tUWtZye99oJ4VxF289J3gQJPfnbfNKwtDayYfiB3s5
	X6bdwTFa+9cwUss/Fr+Mm2LuVoaTYmXFS2y60=
Received: by 10.216.239.71 with SMTP id b49mr1471756wer.107.1304970195275;
	Mon, 09 May 2011 12:43:15 -0700 (PDT)
Received: from bigio.localdomain
	(host25-92-dynamic.4-87-r.retail.telecomitalia.it [87.4.92.25])
	by mx.google.com with ESMTPS id f30sm3187450wef.31.2011.05.09.12.43.12
	(version=TLSv1/SSLv3 cipher=OTHER);
	Mon, 09 May 2011 12:43:13 -0700 (PDT)
From: Stefano Lattarini <stefano.lattarini@HIDDEN>
To: "Ralf Wildenhues" <Ralf.Wildenhues@HIDDEN>
Subject: Re: bug#8635: Some Fortran files don't have the extensions automake
	wants
Date: Mon, 9 May 2011 21:42:57 +0200
User-Agent: KMail/1.13.5 (FreeBSD/8.2-RELEASE; KDE/4.5.5; i386; ; )
References: <1304735907.4245.218.camel@HIDDEN>
	<201105091411.53899.stefano.lattarini@HIDDEN>
	<20110509193336.103040@HIDDEN>
In-Reply-To: <20110509193336.103040@HIDDEN>
X-KMail-Markup: true
MIME-Version: 1.0
Content-Type: multipart/alternative; boundary="Boundary-01=_CPEyNNSJOE4fNoe"
Content-Transfer-Encoding: 7bit
Message-Id: <201105092142.58732.stefano.lattarini@HIDDEN>
X-Spam-Score: -3.6 (---)
X-Debbugs-Envelope-To: 8635
Cc: 8635 <at> debbugs.gnu.org, Peter Williams <pwilliams@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.6 (---)

--Boundary-01=_CPEyNNSJOE4fNoe
Content-Type: text/plain;
  charset="utf-8"
Content-Transfer-Encoding: 7bit

Hi Ralf.

On Monday 09 May 2011, Ralf Wildenhues wrote:
> * Stefano Lattarini wrote on Mon, May 09, 2011 at 02:11:53PM CEST:
> > --- a/automake.in
> > +++ b/automake.in
> > @@ -939,7 +939,7 @@ register_language ('name' => 'f77',
> >  		   'lder' => 'F77LD',
> >  		   'ld' => '$(F77)',
> >  		   'pure' => 1,
> > -		   'extensions' => ['.f', '.for']);
> > +		   'extensions' => ['.f']);
> >  
> >  # Fortran
> >  register_language ('name' => 'fc',
> > @@ -957,7 +957,7 @@ register_language ('name' => 'fc',
> >  		   'lder' => 'FCLD',
> >  		   'ld' => '$(FC)',
> >  		   'pure' => 1,
> > -		   'extensions' => ['.f90', '.f95', '.f03', '.f08']);
> > +		   'extensions' => ['.for', '.f90', '.f95', '.f03', '.f08']);
> >  
> >  # Preprocessed Fortran
> >  register_language ('name' => 'ppfc',
> 
> Sorry, but this is not a good change, and it is backward-incompatible
> (even if .for might not have been used much in practice).
>
Sorry if I hadn't been clear: my intention was *not* for this patch to be
applied to the automake official repository; it was just intended as a quick
workaround for Peter.  See also my other mail in this thread.

> My intention with the recent Autoconf Fortran changes was to go ahead
> and let Automake grab those extensions for $(FC) for which an
> AC_FC_SRCEXT was issued.  And assume preprocessing for those where
> AC_FC_PP_SRCEXT was issued for.  But that is a bigger change.
>
My fortran fu is pretty weak, so I'm happily going to follow your lead
here.

> Cheers, and sorry for my really slow catchup
> (also, all of my mail from yesterday got stuck somewhere...)
>
Too bad :-(

> Ralf
> 

Regards,
  Stefano

--Boundary-01=_CPEyNNSJOE4fNoe
Content-Type: text/html;
  charset="utf-8"
Content-Transfer-Encoding: 7bit

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN" "http://www.w3.org/TR/REC-html40/strict.dtd">
<html><head><meta name="qrichtext" content="1" /><style type="text/css">
p, li { white-space: pre-wrap; }
</style></head><body style=" font-family:'Bitstream Vera Sans Mono'; font-size:12pt; font-weight:400; font-style:normal;">
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">Hi Ralf.</p>
<p style="-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;"></p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">On Monday 09 May 2011, Ralf Wildenhues wrote:</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; * Stefano Lattarini wrote on Mon, May 09, 2011 at 02:11:53PM CEST:</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; --- a/automake.in</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; +++ b/automake.in</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; @@ -939,7 +939,7 @@ register_language ('name' =&gt; 'f77',</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt;  		   'lder' =&gt; 'F77LD',</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt;  		   'ld' =&gt; '$(F77)',</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt;  		   'pure' =&gt; 1,</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; -		   'extensions' =&gt; ['.f', '.for']);</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; +		   'extensions' =&gt; ['.f']);</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt;  </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt;  # Fortran</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt;  register_language ('name' =&gt; 'fc',</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; @@ -957,7 +957,7 @@ register_language ('name' =&gt; 'fc',</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt;  		   'lder' =&gt; 'FCLD',</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt;  		   'ld' =&gt; '$(FC)',</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt;  		   'pure' =&gt; 1,</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; -		   'extensions' =&gt; ['.f90', '.f95', '.f03', '.f08']);</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; +		   'extensions' =&gt; ['.for', '.f90', '.f95', '.f03', '.f08']);</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt;  </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt;  # Preprocessed Fortran</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt;  register_language ('name' =&gt; 'ppfc',</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; Sorry, but this is not a good change, and it is backward-incompatible</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; (even if .for might not have been used much in practice).</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt;</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">Sorry if I hadn't been clear: my intention was *not* for this patch to be</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">applied to the automake official repository; it was just intended as a quick</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">workaround for Peter.  See also my other mail in this thread.</p>
<p style="-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;"></p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; My intention with the recent Autoconf Fortran changes was to go ahead</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; and let Automake grab those extensions for $(FC) for which an</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; AC_FC_SRCEXT was issued.  And assume preprocessing for those where</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; AC_FC_PP_SRCEXT was issued for.  But that is a bigger change.</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt;</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">My fortran fu is pretty weak, so I'm happily going to follow your lead</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">here.</p>
<p style="-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;"></p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; Cheers, and sorry for my really slow catchup</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; (also, all of my mail from yesterday got stuck somewhere...)</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt;</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">Too bad :-(</p>
<p style="-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;"></p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; Ralf</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; </p>
<p style="-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;"></p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">Regards,</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">  Stefano</p></body></html>
--Boundary-01=_CPEyNNSJOE4fNoe--




Information forwarded to owner <at> debbugs.gnu.org, bug-automake@HIDDEN:
bug#8635; Package automake. Full text available.

Message received at 8635 <at> debbugs.gnu.org:


Received: (at 8635) by debbugs.gnu.org; 9 May 2011 19:40:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 09 15:40:37 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1QJWJp-000834-Cc
	for submit <at> debbugs.gnu.org; Mon, 09 May 2011 15:40:37 -0400
Received: from mail-ww0-f46.google.com ([74.125.82.46])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1QJWJj-00082o-EE
	for 8635 <at> debbugs.gnu.org; Mon, 09 May 2011 15:40:36 -0400
Received: by wwb28 with SMTP id 28so5978173wwb.15
	for <8635 <at> debbugs.gnu.org>; Mon, 09 May 2011 12:40:25 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=domainkey-signature:from:to:subject:date:user-agent:cc:references
	:in-reply-to:x-kmail-markup:mime-version:content-type
	:content-transfer-encoding:message-id;
	bh=EQ0Jc76nzmD8RRMdY8wf6OpngOWa/05LhTO+IXb0Y38=;
	b=KeE3XQqR8yOrJ5bDEJcFZZJJMDAFcK74iBhpKI6c/T4ZKkL6QtsBZmAYIAmmG16ROS
	yj3Wep1nw8udzMKMnmC25kR912yqEUATnvc6wyiLkxNHNq4D18HBkFz6ktMnn72HYYzO
	bT6eLP2TnxbPZaZseYfXV2mhz0tmIaBDHmDro=
DomainKey-Signature: a=rsa-sha1; c=nofws; d=gmail.com; s=gamma;
	h=from:to:subject:date:user-agent:cc:references:in-reply-to
	:x-kmail-markup:mime-version:content-type:content-transfer-encoding
	:message-id;
	b=ezXbNPxDKCLoDUAGlzas+wWT23XW/3L6QXQRB09eLu5k8hvcIiAZMFB3UVGEZ3Hugy
	Ixmo142ulX8VkD339YHmOdDSWpVWEk1YpGB9FEgeChjwGtpNJIZJf3M7PnSgWQD+cEwk
	fX4N/THIhnSWzeSRRudlGd4Y6Z6X6IIVyXMic=
Received: by 10.227.195.145 with SMTP id ec17mr7544790wbb.88.1304970025558;
	Mon, 09 May 2011 12:40:25 -0700 (PDT)
Received: from bigio.localdomain
	(host25-92-dynamic.4-87-r.retail.telecomitalia.it [87.4.92.25])
	by mx.google.com with ESMTPS id bs4sm3957279wbb.18.2011.05.09.12.40.23
	(version=TLSv1/SSLv3 cipher=OTHER);
	Mon, 09 May 2011 12:40:24 -0700 (PDT)
From: Stefano Lattarini <stefano.lattarini@HIDDEN>
To: Peter Williams <pwilliams@HIDDEN>
Subject: Re: bug#8635: Some Fortran files don't have the extensions automake
	wants
Date: Mon, 9 May 2011 21:40:09 +0200
User-Agent: KMail/1.13.5 (FreeBSD/8.2-RELEASE; KDE/4.5.5; i386; ; )
References: <1304735907.4245.218.camel@HIDDEN>
	<201105091411.53899.stefano.lattarini@HIDDEN>
	<1304966145.4245.229.camel@HIDDEN>
In-Reply-To: <1304966145.4245.229.camel@HIDDEN>
X-KMail-Markup: true
MIME-Version: 1.0
Content-Type: multipart/alternative; boundary="Boundary-01=_ZMEyNPCVaUBb+JO"
Content-Transfer-Encoding: 7bit
Message-Id: <201105092140.09908.stefano.lattarini@HIDDEN>
X-Spam-Score: -3.6 (---)
X-Debbugs-Envelope-To: 8635
Cc: 8635 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.6 (---)

--Boundary-01=_ZMEyNPCVaUBb+JO
Content-Type: text/plain;
  charset="utf-8"
Content-Transfer-Encoding: 7bit

On Monday 09 May 2011, Peter Williams wrote:
> Hi Stefano,
> 
> Thanks for your prompt reply.
> 
> On Mon, 2011-05-09 at 14:11 +0200, Stefano Lattarini wrote:
> > severity 8635 wishlist
> > thanks
> > 
> > On Saturday 07 May 2011, Peter Williams wrote:
> > > I'm working on wrapping a large, preexisting piece of Fortran code with
> > > an Autotools-based build system. The code is written in Fortran 90 and
> > > uses ".for" for the file extension. Unfortunately, automake ...
> > >
> > I assume you are using automake 1.11.1, right?
> 
> Yes.
> 
> > Please try the attached patch (against the v1.11.1 tag in the automake git
> > repository).  I *think* it should solve your problem for what concerns
> > automake.  However, note that the GNU Fortran Compiler will still consider
> > `*.for' files to be Fortran 77 by default, so you'll have to instruct it
> > to explicitly assume free-form Fortran 90 input, with .e.g.:
> > 
> >   $ ./configure FCFLAGS='-ffree-form -x f95' LDFLAGS='-x none'
> > 
> > This solution is probably not the best one, and is certainly not pretty,
> > but it should work.  If you can come up with a more general one, I'd be
> > happy to hear about it.
> 
> This does work. Do you think this change would be applied to released
> versions of automake, though?
>
Certainly no; the current automake behaviour w.r.t. the `.for' extension
has been in place for a long time, and it matches gfortran expectations,
so there's no reason to just change it.  But making it configurable could
be a useful improvement.

> I don't think developers would be too
> happy about needing to run a custom-patched version of automake.
>
That's understandable.  Unfortunately, the lack of easy extesibility is
a known problem of Automake, and IMHO its major shortcoming.

> I was thinking that there could be an Autoconf macro called 
> 
> AM_ALIAS_SOURCE_EXTENSION([.for],[.f90])
> 
> that would mutate the %extension_map variable to treat .for files the
> way that .f90 files are normally treated. It looks like this could
> happen in &scan_autoconf_traces. I don't have a good enough
> understanding of the automake internals to know whether this would be a
> simple change or whether that would affect a lot of other things,
> though.
>
Hmm... I don't like this solution either; it still sounds a little too
hackish, and to me it seems wrong to have to declare project policy
decisions that are system-independent and relevant only for automake (in
this case, the policy decision being "use the `*.for' extension for
Fortran 90 sources") in the configure.ac file.

OTOH, some times ago a patch has been proposed which would allow user
extensions to the languages handled/understood by Automake:
 <http://lists.gnu.org/archive/html/automake/2010-09/msg00003.html>
IMHO, resurrecting it (and possibly improving it to naturally serve your
user case) would be the best way to fix your problem (and similar ones)
in the long run.

Regards,
  Stefano

--Boundary-01=_ZMEyNPCVaUBb+JO
Content-Type: text/html;
  charset="utf-8"
Content-Transfer-Encoding: 7bit

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN" "http://www.w3.org/TR/REC-html40/strict.dtd">
<html><head><meta name="qrichtext" content="1" /><style type="text/css">
p, li { white-space: pre-wrap; }
</style></head><body style=" font-family:'Bitstream Vera Sans Mono'; font-size:12pt; font-weight:400; font-style:normal;">
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">On Monday 09 May 2011, Peter Williams wrote:</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; Hi Stefano,</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; Thanks for your prompt reply.</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; On Mon, 2011-05-09 at 14:11 +0200, Stefano Lattarini wrote:</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; severity 8635 wishlist</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; thanks</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; On Saturday 07 May 2011, Peter Williams wrote:</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; &gt; I'm working on wrapping a large, preexisting piece of Fortran code with</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; &gt; an Autotools-based build system. The code is written in Fortran 90 and</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; &gt; uses &quot;.for&quot; for the file extension. Unfortunately, automake ...</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; &gt;</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; I assume you are using automake 1.11.1, right?</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; Yes.</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; Please try the attached patch (against the v1.11.1 tag in the automake git</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; repository).  I *think* it should solve your problem for what concerns</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; automake.  However, note that the GNU Fortran Compiler will still consider</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; `*.for' files to be Fortran 77 by default, so you'll have to instruct it</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; to explicitly assume free-form Fortran 90 input, with .e.g.:</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt;   $ ./configure FCFLAGS='-ffree-form -x f95' LDFLAGS='-x none'</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; This solution is probably not the best one, and is certainly not pretty,</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; but it should work.  If you can come up with a more general one, I'd be</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; &gt; happy to hear about it.</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; This does work. Do you think this change would be applied to released</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; versions of automake, though?</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt;</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">Certainly no; the current automake behaviour w.r.t. the `.for' extension</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">has been in place for a long time, and it matches gfortran expectations,</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">so there's no reason to just change it.  But making it configurable could</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">be a useful improvement.</p>
<p style="-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;"></p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; I don't think developers would be too</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; happy about needing to run a custom-patched version of automake.</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt;</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">That's understandable.  Unfortunately, the lack of easy extesibility is</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">a known problem of Automake, and IMHO its major shortcoming.</p>
<p style="-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;"></p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; I was thinking that there could be an Autoconf macro called </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; AM_ALIAS_SOURCE_EXTENSION([.for],[.f90])</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; </p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; that would mutate the %extension_map variable to treat .for files the</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; way that .f90 files are normally treated. It looks like this could</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; happen in &amp;scan_autoconf_traces. I don't have a good enough</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; understanding of the automake internals to know whether this would be a</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; simple change or whether that would affect a lot of other things,</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt; though.</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">&gt;</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">Hmm... I don't like this solution either; it still sounds a little too</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">hackish, and to me it seems wrong to have to declare project policy</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">decisions that are system-independent and relevant only for automake (in</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">this case, the policy decision being &quot;use the `*.for' extension for</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">Fortran 90 sources&quot;) in the configure.ac file.</p>
<p style="-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;"></p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">OTOH, some times ago a patch has been proposed which would allow user</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">extensions to the languages handled/understood by Automake:</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;"> &lt;http://lists.gnu.org/archive/html/automake/2010-09/msg00003.html&gt;</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">IMHO, resurrecting it (and possibly improving it to naturally serve your</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">user case) would be the best way to fix your problem (and similar ones)</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">in the long run.</p>
<p style="-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;"></p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">Regards,</p>
<p style=" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; -qt-user-state:0;">  Stefano</p></body></html>
--Boundary-01=_ZMEyNPCVaUBb+JO--




Information forwarded to owner <at> debbugs.gnu.org, bug-automake@HIDDEN:
bug#8635; Package automake. Full text available.

Message received at 8635 <at> debbugs.gnu.org:


Received: (at 8635) by debbugs.gnu.org; 9 May 2011 19:33:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 09 15:33:46 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1QJWDC-0007tW-3c
	for submit <at> debbugs.gnu.org; Mon, 09 May 2011 15:33:46 -0400
Received: from mailout-de.gmx.net ([213.165.64.23])
	by debbugs.gnu.org with smtp (Exim 4.69)
	(envelope-from <Ralf.Wildenhues@HIDDEN>) id 1QJWD9-0007tI-PQ
	for 8635 <at> debbugs.gnu.org; Mon, 09 May 2011 15:33:44 -0400
Received: (qmail 9872 invoked by uid 0); 9 May 2011 19:33:36 -0000
Received: from 217.162.96.195 by www157.gmx.net with HTTP;
	Mon, 09 May 2011 21:33:36 +0200 (CEST)
Content-Type: text/plain; charset="utf-8"
Date: Mon, 09 May 2011 21:33:36 +0200
From: "Ralf Wildenhues" <Ralf.Wildenhues@HIDDEN>
In-Reply-To: <201105091411.53899.stefano.lattarini@HIDDEN>
Message-ID: <20110509193336.103040@HIDDEN>
MIME-Version: 1.0
References: <1304735907.4245.218.camel@HIDDEN>
	<201105091411.53899.stefano.lattarini@HIDDEN>
Subject: Re: bug#8635: Some Fortran files don't have the extensions automake
	wants
To: Stefano Lattarini <stefano.lattarini@HIDDEN>
X-Authenticated: #13673931
X-Flags: 0001
X-Mailer: WWW-Mail 6100 (Global Message Exchange)
X-Mutt-Fcc: +bug-automake
X-Mutt-References: <201105091411.53899.stefano.lattarini@HIDDEN>
X-Priority: 3
X-Provags-ID: V01U2FsdGVkX18QPd55r0IQuV2G4/c4WWBKwmqVx7MfDWftV2jliV
	5yBuB8DWi7xeRpIrz7/6vDVWl/2mor4WWdOw== 
Content-Transfer-Encoding: 8bit
X-GMX-UID: p3n+fHIbYmYBBv2StXc3uL9CWkZTQRRo
X-Spam-Score: -2.6 (--)
X-Debbugs-Envelope-To: 8635
Cc: 8635 <at> debbugs.gnu.org, Peter Williams <pwilliams@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

* Stefano Lattarini wrote on Mon, May 09, 2011 at 02:11:53PM CEST:
> --- a/automake.in
> +++ b/automake.in
> @@ -939,7 +939,7 @@ register_language ('name' => 'f77',
>  		   'lder' => 'F77LD',
>  		   'ld' => '$(F77)',
>  		   'pure' => 1,
> -		   'extensions' => ['.f', '.for']);
> +		   'extensions' => ['.f']);
>  
>  # Fortran
>  register_language ('name' => 'fc',
> @@ -957,7 +957,7 @@ register_language ('name' => 'fc',
>  		   'lder' => 'FCLD',
>  		   'ld' => '$(FC)',
>  		   'pure' => 1,
> -		   'extensions' => ['.f90', '.f95', '.f03', '.f08']);
> +		   'extensions' => ['.for', '.f90', '.f95', '.f03', '.f08']);
>  
>  # Preprocessed Fortran
>  register_language ('name' => 'ppfc',

Sorry, but this is not a good change, and it is backward-incompatible
(even if .for might not have been used much in practice).

My intention with the recent Autoconf Fortran changes was to go ahead
and let Automake grab those extensions for $(FC) for which an
AC_FC_SRCEXT was issued.  And assume preprocessing for those where
AC_FC_PP_SRCEXT was issued for.  But that is a bigger change.

Cheers, and sorry for my really slow catchup
(also, all of my mail from yesterday got stuck somewhere...)
Ralf




Information forwarded to owner <at> debbugs.gnu.org, bug-automake@HIDDEN:
bug#8635; Package automake. Full text available.

Message received at 8635 <at> debbugs.gnu.org:


Received: (at 8635) by debbugs.gnu.org; 9 May 2011 18:35:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 09 14:35:54 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1QJVJB-0006Z5-D1
	for submit <at> debbugs.gnu.org; Mon, 09 May 2011 14:35:53 -0400
Received: from chandra.berkeley.edu ([128.32.92.22])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <pwilliams@HIDDEN>) id 1QJVJ9-0006Yr-LE
	for 8635 <at> debbugs.gnu.org; Mon, 09 May 2011 14:35:52 -0400
Received: from [128.32.92.174] (cosmic [128.32.92.174])
	by chandra.berkeley.edu (Postfix) with ESMTP id 8B4F1848DB;
	Mon,  9 May 2011 11:35:45 -0700 (PDT)
Subject: Re: bug#8635: Some Fortran files don't have the extensions
	automake wants
From: Peter Williams <pwilliams@HIDDEN>
To: Stefano Lattarini <stefano.lattarini@HIDDEN>
In-Reply-To: <201105091411.53899.stefano.lattarini@HIDDEN>
References: <1304735907.4245.218.camel@HIDDEN>
	<201105091411.53899.stefano.lattarini@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Organization: Astronomy Department, UC Berkeley
Date: Mon, 09 May 2011 11:35:45 -0700
Message-ID: <1304966145.4245.229.camel@HIDDEN>
Mime-Version: 1.0
X-Mailer: Evolution 2.28.2 
Content-Transfer-Encoding: 7bit
X-Spam-Score: -6.6 (------)
X-Debbugs-Envelope-To: 8635
Cc: 8635 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.6 (------)

Hi Stefano,

Thanks for your prompt reply.

On Mon, 2011-05-09 at 14:11 +0200, Stefano Lattarini wrote:
> severity 8635 wishlist
> thanks
> 
> On Saturday 07 May 2011, Peter Williams wrote:
> > I'm working on wrapping a large, preexisting piece of Fortran code with
> > an Autotools-based build system. The code is written in Fortran 90 and
> > uses ".for" for the file extension. Unfortunately, automake ...
> >
> I assume you are using automake 1.11.1, right?

Yes.

> Please try the attached patch (against the v1.11.1 tag in the automake git
> repository).  I *think* it should solve your problem for what concerns
> automake.  However, note that the GNU Fortran Compiler will still consider
> `*.for' files to be Fortran 77 by default, so you'll have to instruct it
> to explicitly assume free-form Fortran 90 input, with .e.g.:
> 
>   $ ./configure FCFLAGS='-ffree-form -x f95' LDFLAGS='-x none'
> 
> This solution is probably not the best one, and is certainly not pretty,
> but it should work.  If you can come up with a more general one, I'd be
> happy to hear about it.

This does work. Do you think this change would be applied to released
versions of automake, though? I don't think developers would be too
happy about needing to run a custom-patched version of automake.

I was thinking that there could be an Autoconf macro called 

AM_ALIAS_SOURCE_EXTENSION([.for],[.f90])

that would mutate the %extension_map variable to treat .for files the
way that .f90 files are normally treated. It looks like this could
happen in &scan_autoconf_traces. I don't have a good enough
understanding of the automake internals to know whether this would be a
simple change or whether that would affect a lot of other things,
though.

Peter


> 
> > Thanks,
> > 
> > Peter
> > 
> 
> HTH,
>   Stefano

-- 
Peter Williams / pwilliams@HIDDEN
Department of Astronomy, UC Berkeley





Information forwarded to owner <at> debbugs.gnu.org, bug-automake@HIDDEN:
bug#8635; Package automake. Full text available.
Severity set to 'wishlist' from 'normal' Request was from Stefano Lattarini <stefano.lattarini@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 8635 <at> debbugs.gnu.org:


Received: (at 8635) by debbugs.gnu.org; 9 May 2011 12:12:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 09 08:12:14 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1QJPJt-0004Et-9o
	for submit <at> debbugs.gnu.org; Mon, 09 May 2011 08:12:13 -0400
Received: from mail-ww0-f46.google.com ([74.125.82.46])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <stefano.lattarini@HIDDEN>)
	id 1QJPJr-0004Ed-0O; Mon, 09 May 2011 08:12:11 -0400
Received: by wwb28 with SMTP id 28so5491229wwb.15
	for <multiple recipients>; Mon, 09 May 2011 05:12:05 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=domainkey-signature:from:to:subject:date:user-agent:cc:references
	:in-reply-to:mime-version:content-type:message-id;
	bh=4ziIUmMX5NY3ldIXHQvVxmFiPpiKOkt+F7J0k1u8u2w=;
	b=on9cg8hMazZ4z2T8Uh4Iz/ESUD85Hj/56+OM1rffAahm3ISI65wgU29osX2O04cqVt
	wZY4HOu2NH9oeXQ26g2KdFfzq24SxJV6Stawx3W2VzkPgrJ6eshHydBjYROTQIuZ4AOU
	ICgY4jYQG3PTWw1mG6eJE/pFuB2maRctbDPTU=
DomainKey-Signature: a=rsa-sha1; c=nofws; d=gmail.com; s=gamma;
	h=from:to:subject:date:user-agent:cc:references:in-reply-to
	:mime-version:content-type:message-id;
	b=a8qPxqSiXwv0oFFMERJ7Q6lTGgxhXxUfrgztnnYgwIkyWhsR0+Km+fu5OJaA8A7ZB1
	cgvo2f6XlTeWLBt1eWpVJyv+yUEzRVqiDfn31oSgY0bHVlcE8xRKMqQTgmBGaPUTKN8D
	5Jig3LLnCTu8OY9LkjLBiyCOaJ7e63D0+R6l4=
Received: by 10.227.32.73 with SMTP id b9mr5412712wbd.86.1304943125009;
	Mon, 09 May 2011 05:12:05 -0700 (PDT)
Received: from bigio.localnet
	(host139-49-dynamic.58-82-r.retail.telecomitalia.it [82.58.49.139])
	by mx.google.com with ESMTPS id b6sm3422059wby.28.2011.05.09.05.12.02
	(version=TLSv1/SSLv3 cipher=OTHER);
	Mon, 09 May 2011 05:12:03 -0700 (PDT)
From: Stefano Lattarini <stefano.lattarini@HIDDEN>
To: Peter Williams <pwilliams@HIDDEN>
Subject: Re: bug#8635: Some Fortran files don't have the extensions automake
	wants
Date: Mon, 9 May 2011 14:11:53 +0200
User-Agent: KMail/1.13.3 (Linux/2.6.30-2-686; KDE/4.4.4; i686; ; )
References: <1304735907.4245.218.camel@HIDDEN>
In-Reply-To: <1304735907.4245.218.camel@HIDDEN>
MIME-Version: 1.0
Content-Type: Multipart/Mixed;
  boundary="Boundary-00=_Jo9xN2rxkmbcXS+"
Message-Id: <201105091411.53899.stefano.lattarini@HIDDEN>
X-Spam-Score: -3.6 (---)
X-Debbugs-Envelope-To: 8635
Cc: 8635 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.6 (---)

--Boundary-00=_Jo9xN2rxkmbcXS+
Content-Type: Text/Plain;
  charset="utf-8"
Content-Transfer-Encoding: 7bit

severity 8635 wishlist
thanks

On Saturday 07 May 2011, Peter Williams wrote:
> I'm working on wrapping a large, preexisting piece of Fortran code with
> an Autotools-based build system. The code is written in Fortran 90 and
> uses ".for" for the file extension. Unfortunately, automake ...
>
I assume you are using automake 1.11.1, right?

> ... thinks that ".for" files are Fortran 77 code, so the wrong compiler
> gets used and chokes on the F90 constructs.
> 
> It's not practical for me to rename the files -- tracking upstream would
> become impossible. Would it be possible to provide a way for me to tell
> automake that my .for files are actually Fortran 90, not Fortran 77? As
> far as I can tell, this mapping is simply hardcoded in /usr/bin/automake.
>
You're right.

> It wouldn't be the most pleasant, but it'd suffice
> if there were some global variable that I could set that would say "hey,
> Automake, .for files are F90". One could imagine more generic solutions
> as well, but Fortran is probably the only language that has these kinds
> of problems.
>
Please try the attached patch (against the v1.11.1 tag in the automake git
repository).  I *think* it should solve your problem for what concerns
automake.  However, note that the GNU Fortran Compiler will still consider
`*.for' files to be Fortran 77 by default, so you'll have to instruct it
to explicitly assume free-form Fortran 90 input, with .e.g.:

  $ ./configure FCFLAGS='-ffree-form -x f95' LDFLAGS='-x none'

This solution is probably not the best one, and is certainly not pretty,
but it should work.  If you can come up with a more general one, I'd be
happy to hear about it.

> Thanks,
> 
> Peter
> 

HTH,
  Stefano

--Boundary-00=_Jo9xN2rxkmbcXS+
Content-Type: text/x-patch;
  charset="utf-8";
  name="fortran.patch"
Content-Transfer-Encoding: 7bit
Content-Disposition: inline;
	filename="fortran.patch"

diff --git a/automake.in b/automake.in
index e934c5f..23392a8 100755
--- a/automake.in
+++ b/automake.in
@@ -939,7 +939,7 @@ register_language ('name' => 'f77',
 		   'lder' => 'F77LD',
 		   'ld' => '$(F77)',
 		   'pure' => 1,
-		   'extensions' => ['.f', '.for']);
+		   'extensions' => ['.f']);
 
 # Fortran
 register_language ('name' => 'fc',
@@ -957,7 +957,7 @@ register_language ('name' => 'fc',
 		   'lder' => 'FCLD',
 		   'ld' => '$(FC)',
 		   'pure' => 1,
-		   'extensions' => ['.f90', '.f95', '.f03', '.f08']);
+		   'extensions' => ['.for', '.f90', '.f95', '.f03', '.f08']);
 
 # Preprocessed Fortran
 register_language ('name' => 'ppfc',

--Boundary-00=_Jo9xN2rxkmbcXS+--




Information forwarded to owner <at> debbugs.gnu.org, bug-automake@HIDDEN:
bug#8635; Package automake. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 7 May 2011 17:13:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 07 13:13:56 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1QIl4l-0000hZ-9N
	for submit <at> debbugs.gnu.org; Sat, 07 May 2011 13:13:56 -0400
Received: from eggs.gnu.org ([140.186.70.92])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <pwilliams@HIDDEN>) id 1QIXPi-0005ii-VE
	for submit <at> debbugs.gnu.org; Fri, 06 May 2011 22:38:39 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <pwilliams@HIDDEN>) id 1QIXPd-0005BO-10
	for submit <at> debbugs.gnu.org; Fri, 06 May 2011 22:38:33 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.1 (2010-03-16) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-4.2 required=5.0 tests=BAYES_00,RCVD_IN_DNSWL_MED,
	T_RP_MATCHES_RCVD autolearn=unavailable version=3.3.1
Received: from lists.gnu.org ([140.186.70.17]:50094)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <pwilliams@HIDDEN>) id 1QIXPc-0005BK-Vg
	for submit <at> debbugs.gnu.org; Fri, 06 May 2011 22:38:32 -0400
Received: from eggs.gnu.org ([140.186.70.92]:47179)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <pwilliams@HIDDEN>) id 1QIXPb-0002Y4-UT
	for bug-automake@HIDDEN; Fri, 06 May 2011 22:38:32 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <pwilliams@HIDDEN>) id 1QIXPa-0005B6-Vz
	for bug-automake@HIDDEN; Fri, 06 May 2011 22:38:31 -0400
Received: from chandra.berkeley.edu ([128.32.92.22]:60462)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <pwilliams@HIDDEN>) id 1QIXPa-0005B1-Qi
	for bug-automake@HIDDEN; Fri, 06 May 2011 22:38:30 -0400
Received: from [128.32.92.174] (cosmic [128.32.92.174])
	by chandra.berkeley.edu (Postfix) with ESMTP id 47C19888FA
	for <bug-automake@HIDDEN>; Fri,  6 May 2011 19:38:28 -0700 (PDT)
Subject: Some Fortran files don't have the extensions automake wants
From: Peter Williams <pwilliams@HIDDEN>
To: bug-automake@HIDDEN
Content-Type: text/plain; charset="UTF-8"
Organization: Astronomy Department, UC Berkeley
Date: Fri, 06 May 2011 19:38:27 -0700
Message-ID: <1304735907.4245.218.camel@HIDDEN>
Mime-Version: 1.0
X-Mailer: Evolution 2.28.2 
Content-Transfer-Encoding: 7bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6, seldom 2.4 (older,
	4)
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6 (newer, 3)
X-Received-From: 140.186.70.17
X-Spam-Score: -6.6 (------)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Sat, 07 May 2011 13:13:54 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.6 (------)

I'm working on wrapping a large, preexisting piece of Fortran code with
an Autotools-based build system. The code is written in Fortran 90 and
uses ".for" for the file extension. Unfortunately, automake thinks that
".for" files are Fortran 77 code, so the wrong compiler gets used and
chokes on the F90 constructs.

It's not practical for me to rename the files -- tracking upstream would
become impossible. Would it be possible to provide a way for me to tell
automake that my .for files are actually Fortran 90, not Fortran 77? As
far as I can tell, this mapping is simply hardcoded
in /usr/bin/automake. It wouldn't be the most pleasant, but it'd suffice
if there were some global variable that I could set that would say "hey,
Automake, .for files are F90". One could imagine more generic solutions
as well, but Fortran is probably the only language that has these kinds
of problems.

Thanks,

Peter

-- 
Peter Williams / pwilliams@HIDDEN
Department of Astronomy, UC Berkeley





Acknowledgement sent to Peter Williams <pwilliams@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-automake@HIDDEN. Full text available.
Report forwarded to owner <at> debbugs.gnu.org, bug-automake@HIDDEN:
bug#8635; Package automake. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.